Index: branches/ORCHIDEE_2_2/ORCHIDEE/src_sechiba/routing.f90
===================================================================
--- branches/ORCHIDEE_2_2/ORCHIDEE/src_sechiba/routing.f90	(revision 7576)
+++ branches/ORCHIDEE_2_2/ORCHIDEE/src_sechiba/routing.f90	(revision 7709)
@@ -12,6 +12,6 @@
 !!\n DESCRIPTION: None
 !!
-!! RECENT CHANGE(S): None
-!!
+!! RECENT CHANGE(S): July 2022: New irrigation scheme. Here new irrigation offer with more information from maps, and
+!!                    calculation of water withdrawal.
 !! REFERENCE(S)	:
 !!
@@ -226,7 +226,22 @@
   REAL(r_std), SAVE, ALLOCATABLE, DIMENSION(:)               :: reinfiltration_mean          !! Mean water flow which returns to the grid box (kg/m^2/dt)
 !$OMP THREADPRIVATE(reinfiltration_mean)
+  REAL(r_std), SAVE, ALLOCATABLE, DIMENSION(:)               :: irrigdeficit_mean              !! Mean irrigation deficit.
+                                                                                           !! This is between irrigation and water requirement (kg/m^2/dt)
+!$OMP THREADPRIVATE(irrigdeficit_mean)
   REAL(r_std), SAVE, ALLOCATABLE, DIMENSION(:)               :: irrigation_mean              !! Mean irrigation flux.
                                                                                              !! This is the water taken from the reservoirs and beeing put into the upper layers of the soil (kg/m^2/dt)
 !$OMP THREADPRIVATE(irrigation_mean)
+  REAL(r_std), SAVE, ALLOCATABLE, DIMENSION(:)               :: irrig_gw_source_mean       !! Mean groundwater irrigation flux.
+                                                                                         !! This is the water taken from the GW reservoir only (kg/m^2/dt)
+!$OMP THREADPRIVATE(irrig_gw_source_mean)
+  REAL(r_std), SAVE, ALLOCATABLE, DIMENSION(:)               :: irrig_fast_source_mean       !! Mean irrigation flux from fast.
+                                                                                       !! This is the water taken from the fast reservoir only (kg/m^2/dt)
+!$OMP THREADPRIVATE(irrig_fast_source_mean)
+  REAL(r_std), SAVE, ALLOCATABLE, DIMENSION(:)               :: irrig_str_source_mean       !! Mean streamflow irrigation flux.
+                                                                                       !! This is the water taken from the streamflow reservoir only (kg/m^2/dt)
+!$OMP THREADPRIVATE(irrig_str_source_mean)
+  REAL(r_std), SAVE, ALLOCATABLE, DIMENSION(:)               :: irrigadduct_mean       !! Irrigation that comes from adduction. It includes water from basins inside the grid cell
+                                                                                        ! and water from nearby grid cells
+!$OMP THREADPRIVATE(irrigadduct_mean)
   REAL(r_std), SAVE, ALLOCATABLE, DIMENSION(:)               :: riverflow_mean               !! Mean Outflow of the major rivers.
                                                                                              !! The flux will be located on the continental grid but this should be a coastal point (kg/dt)
@@ -291,6 +306,7 @@
                                 neighbours,  resolution,     contfrac,   stempdiag, &
                                 returnflow,  reinfiltration, irrigation, riverflow, &
-                                coastalflow, flood_frac,     flood_res )
-       
+                                coastalflow, flood_frac,     flood_res, soiltile, irrig_frac, &
+                                veget_max, irrigated_next) !
+
     IMPLICIT NONE
     
@@ -309,4 +325,8 @@
     REAL(r_std), INTENT(in)        :: contfrac(nbpt)       !! Fraction of land in each grid box (unitless;0-1)
     REAL(r_std), INTENT(in)        :: stempdiag(nbpt,nslm) !! Diagnostic soil temperature profile
+    REAL(r_std), INTENT(in)        :: soiltile(nbpt,nstm)  !! Fraction of each soil tile within vegtot (0-1, unitless)
+    REAL(r_std), INTENT(in)        :: veget_max(nbpt,nvm)  !! Maximal fraction of vegetation (unitless;0-1) !
+    REAL(r_std), INTENT(in)        :: irrigated_next (nbpt)  !! Dynamic irrig. area, calculated in slowproc and passed to routing!
+    REAL(r_std), INTENT(in)        :: irrig_frac(nbpt)      !! Irrig. fraction interpolated in routing, and saved to pass to slowproc if irrigated_soiltile = .TRUE.
 
     !! 0.2 Output variables
@@ -323,5 +343,5 @@
     !! 0.3 Local variables
     REAL(r_std), DIMENSION(nbp_glo):: mask_coast_glo       !! Mask with coastal gridcells on global grid (1/0)
-    LOGICAL                        :: init_irrig           !! Logical to initialize the irrigation (true/false)
+    !LOGICAL                        :: init_irrig          !! Logical to initialize the irrigation (true/false)
     LOGICAL                        :: init_flood           !! Logical to initialize the floodplains (true/false)
     LOGICAL                        :: init_swamp           !! Logical to initialize the swamps (true/false)
@@ -385,7 +405,6 @@
     !! Initialisation of flags for irrigated land, flood plains and swamps
     !
-    init_irrig = .FALSE.
     IF ( do_irrigation ) THEN 
-       IF (COUNT(irrigated .GE. undef_sechiba-1) > 0) init_irrig = .TRUE.
+       irrigated(:) = irrigated_next(:)
     END IF
     
@@ -399,49 +418,19 @@
        IF (COUNT(swamp .GE. undef_sechiba-1) > 0 ) init_swamp = .TRUE.
     END IF
-       
+
     !! If we have irrigated land, flood plains or swamps then we need to interpolate the 0.5 degree
     !! base data set to the resolution of the model.
-    
-    IF ( init_irrig .OR. init_flood .OR. init_swamp ) THEN
-       CALL routing_irrigmap(nbpt, index, lalo, neighbours, resolution, &
-            contfrac, init_irrig, irrigated, init_flood, floodplains, init_swamp, swamp, hist_id, hist2_id)
+    !IF ( init_irrig .OR. init_flood .OR. init_swamp ) THEN
+    IF ( init_flood .OR. init_swamp ) THEN
+       CALL routing_floodmap(nbpt, index, lalo, neighbours, resolution, &
+            contfrac, init_flood, floodplains, init_swamp, swamp, hist_id, hist2_id)
     ENDIF
-    
-    IF ( do_irrigation ) THEN 
-       CALL xios_orchidee_send_field("irrigmap",irrigated)
-       
-       IF (printlev >= 3) WRITE(numout,*) 'Verification : range of irrigated : ', MINVAL(irrigated), MAXVAL(irrigated) 
-       IF ( .NOT. almaoutput ) THEN
-          CALL histwrite_p(hist_id, 'irrigmap', 1, irrigated, nbpt, index)
-       ELSE
-          CALL histwrite_p(hist_id, 'IrrigationMap', 1, irrigated, nbpt, index)
-       ENDIF
-       IF ( hist2_id > 0 ) THEN
-          IF ( .NOT. almaoutput ) THEN
-             CALL histwrite_p(hist2_id, 'irrigmap', 1, irrigated, nbpt, index)
-          ELSE
-             CALL histwrite_p(hist2_id, 'IrrigationMap', 1, irrigated, nbpt, index)
-          ENDIF
-       ENDIF
+
+    IF ( do_irrigation ) THEN
+
+       IF (printlev >= 3) WRITE(numout,*) 'Verification : range of irrigated : ', MINVAL(irrigated), MAXVAL(irrigated)
+       IF (printlev >= 3) WRITE(numout,*) 'Verification : range of irrig_frac : ', MINVAL(irrig_frac), MAXVAL(irrig_frac)
     ENDIF
-    
-    IF ( do_floodplains ) THEN
-       CALL xios_orchidee_send_field("floodmap",floodplains)
-       
-       IF (printlev>=3) WRITE(numout,*) 'Verification : range of floodplains : ', MINVAL(floodplains), MAXVAL(floodplains) 
-       IF ( .NOT. almaoutput ) THEN
-          CALL histwrite_p(hist_id, 'floodmap', 1, floodplains, nbpt, index)
-       ELSE
-          CALL histwrite_p(hist_id, 'FloodplainsMap', 1, floodplains, nbpt, index)
-       ENDIF
-       IF ( hist2_id > 0 ) THEN
-          IF ( .NOT. almaoutput ) THEN
-             CALL histwrite_p(hist2_id, 'floodmap', 1, floodplains, nbpt, index)
-          ELSE
-             CALL histwrite_p(hist2_id, 'FloodplainsMap', 1, floodplains, nbpt, index)
-          ENDIF
-       ENDIF
-    ENDIF
-    
+
     IF ( doswamps ) THEN
        CALL xios_orchidee_send_field("swampmap",swamp)
@@ -558,5 +547,6 @@
        & lalo, neighbours, resolution, contfrac, totfrac_nobio, veget_max, floodout, runoff, &
        & drainage, transpot, precip_rain, humrel, k_litt, flood_frac, flood_res, &
-       & stempdiag, reinf_slope, returnflow, reinfiltration, irrigation, riverflow, coastalflow, rest_id, hist_id, hist2_id)
+       & stempdiag, reinf_slope, returnflow, reinfiltration, irrigation, riverflow, coastalflow, rest_id, hist_id, hist2_id,&
+       soiltile, root_deficit, irrigated_next, irrig_frac, fraction_aeirrig_sw) !
 
     IMPLICIT NONE
@@ -584,4 +574,9 @@
     REAL(r_std), INTENT(in)        :: stempdiag(nbpt,nslm) !! Diagnostic soil temperature profile
     REAL(r_std), INTENT(in)        :: reinf_slope(nbpt)    !! Coefficient which determines the reinfiltration ratio in the grid box due to flat areas (unitless;0-1)
+    REAL(r_std), INTENT(in)        :: root_deficit(nbpt)   !! soil water deficit
+    REAL(r_std), INTENT(in)        :: soiltile(nbpt,nstm)  !! Fraction of each soil tile within vegtot (0-1, unitless)
+    REAL(r_std), INTENT(in)        :: irrig_frac(nbpt)     !! Irrig. fraction interpolated in routing, and saved to pass to slowproc if irrigated_soiltile = .TRUE.
+    REAL(r_std), INTENT(in)        :: irrigated_next (nbpt)!! Dynamic irrig. area, calculated in slowproc and passed to routing
+    REAL(r_std), INTENT(in)        :: fraction_aeirrig_sw(nbpt) !! Fraction of area equipped for irrigation from surface water, of irrig_frac
 
     !! 0.2 Output variables
@@ -670,10 +665,28 @@
     ! the growing seasons we will give more weight to these areas.
     !
-    DO jv=2,nvm
-       DO ig=1,nbpt
-          humrel_mean(ig) = humrel_mean(ig) + humrel(ig,jv)*veget_max(ig,jv)*dt_sechiba/dt_routing
-          vegtot_mean(ig) = vegtot_mean(ig) + veget_max(ig,jv)*dt_sechiba/dt_routing
-       ENDDO
-    ENDDO
+    ! New irrigation scheme uses mean of vegtot with jv 1 to nvm
+    ! Old scheme keeps jv 2 to nvm, even if possibly an error
+    IF ( .NOT. old_irrig_scheme ) THEN
+      DO jv=1,nvm
+         DO ig=1,nbpt
+            humrel_mean(ig) = humrel_mean(ig) + humrel(ig,jv)*veget_max(ig,jv)*dt_sechiba/dt_routing
+            vegtot_mean(ig) = vegtot_mean(ig) + veget_max(ig,jv)*dt_sechiba/dt_routing
+         ENDDO
+      ENDDO
+    ELSE
+      DO jv=2,nvm
+         DO ig=1,nbpt
+            humrel_mean(ig) = humrel_mean(ig) + humrel(ig,jv)*veget_max(ig,jv)*dt_sechiba/dt_routing
+            vegtot_mean(ig) = vegtot_mean(ig) + veget_max(ig,jv)*dt_sechiba/dt_routing
+         ENDDO
+      ENDDO
+    ENDIF
+    ! Here updates irrigmap to irrigated_next from slowproc, every timestep
+    !irrigated_next is updated in slowproc when time comes
+    !irrig_frac was also updated in slowproc, here used as input variable
+
+    IF ( do_irrigation .AND. irrig_map_dynamic_flag  ) THEN
+        irrigated(:) = irrigated_next(:)
+    ENDIF
     !
     time_counter = time_counter + dt_sechiba 
@@ -685,9 +698,11 @@
        !! Computes the transport of water in the various reservoirs
        !
-       CALL routing_flow(nbpt, dt_routing, lalo, floodout_mean, runoff_mean, drainage_mean, &
+       CALL routing_flow(nbpt, dt_routing, lalo, floodout_mean, runoff_mean, drainage_mean, root_deficit, soiltile, &
             & vegtot_mean, totnobio_mean, transpot_mean, precip_mean, humrel_mean, k_litt_mean, floodtemp, reinf_slope, &
-            & lakeinflow_mean, returnflow_mean, reinfiltration_mean, irrigation_mean, riverflow_mean, &
+            & lakeinflow_mean, returnflow_mean, reinfiltration_mean, irrig_frac, irrigation_mean, irrigdeficit_mean, &
+            & irrigadduct_mean, irrig_gw_source_mean, & !
+            & irrig_fast_source_mean, irrig_str_source_mean, riverflow_mean, & !
             & coastalflow_mean, hydrographs, slowflow_diag, flood_frac, flood_res, &
-            & netflow_stream_diag, netflow_fast_diag, netflow_slow_diag)
+            & netflow_stream_diag, netflow_fast_diag, netflow_slow_diag, fraction_aeirrig_sw)
        !
        !! Responsible for storing the water in lakes
@@ -718,4 +733,9 @@
        reinfiltration_mean(:) = reinfiltration_mean(:)/dt_routing*dt_sechiba
        irrigation_mean(:) = irrigation_mean(:)/dt_routing*dt_sechiba
+       irrigdeficit_mean(:) = irrigdeficit_mean/dt_routing*dt_sechiba !
+       irrigadduct_mean(:) = irrigadduct_mean(:)/dt_routing*dt_sechiba!
+       irrig_gw_source_mean(:) = irrig_gw_source_mean(:)/dt_routing*dt_sechiba !
+       irrig_fast_source_mean(:) = irrig_fast_source_mean(:)/dt_routing*dt_sechiba !
+       irrig_str_source_mean(:) = irrig_str_source_mean(:)/dt_routing*dt_sechiba !
        irrig_netereq(:) = irrig_netereq(:)/dt_routing*dt_sechiba
        
@@ -766,4 +786,9 @@
     ! Water fluxes converted from kg/m^2/dt_sechiba into kg/m^2/s 
     CALL xios_orchidee_send_field("irrigation",irrigation/dt_sechiba)
+    CALL xios_orchidee_send_field("irrig_deficit",irrigdeficit_mean/dt_sechiba)!
+    CALL xios_orchidee_send_field("irrig_adduct",irrigadduct_mean/dt_sechiba)!
+    CALL xios_orchidee_send_field("irrig_gw_source",irrig_gw_source_mean/dt_sechiba) !
+    CALL xios_orchidee_send_field("irrig_fast_source",irrig_fast_source_mean/dt_sechiba) !
+    CALL xios_orchidee_send_field("irrig_str_source",irrig_str_source_mean/dt_sechiba) !
     CALL xios_orchidee_send_field("netirrig",irrig_netereq/dt_sechiba)
     CALL xios_orchidee_send_field("riversret",returnflow/dt_sechiba)
@@ -879,5 +904,5 @@
     
     !! 0.2 Local variables
-    REAL(r_std), DIMENSION(1)      :: tmp_day              
+    REAL(r_std), DIMENSION(1)      :: tmp_day
 
 !_ ================================================================================================================================
@@ -931,6 +956,11 @@
 
     IF ( do_irrigation ) THEN
-       CALL restput_p (rest_id, 'irrigated', nbp_glo, 1, 1, kjit, irrigated, 'scatter',  nbp_glo, index_g)
+       !CALL restput_p (rest_id, 'irrigated', nbp_glo, 1, 1, kjit, irrigated, 'scatter',  nbp_glo, index_g)
        CALL restput_p (rest_id, 'irrigation', nbp_glo, 1, 1, kjit, irrigation_mean, 'scatter',  nbp_glo, index_g)
+       CALL restput_p (rest_id, 'irrigdeficit', nbp_glo, 1, 1, kjit, irrigdeficit_mean, 'scatter',  nbp_glo, index_g)
+       CALL restput_p (rest_id, 'irrigadduct', nbp_glo, 1, 1, kjit, irrigadduct_mean, 'scatter',  nbp_glo, index_g)
+       CALL restput_p (rest_id, 'irrig_gw_source', nbp_glo, 1, 1, kjit, irrig_gw_source_mean, 'scatter',  nbp_glo, index_g) !
+       CALL restput_p (rest_id, 'irrig_fast_source', nbp_glo, 1, 1, kjit, irrig_fast_source_mean, 'scatter',  nbp_glo, index_g) !
+       CALL restput_p (rest_id, 'irrig_str_source', nbp_glo, 1, 1, kjit, irrig_str_source_mean, 'scatter',  nbp_glo, index_g) !
     ENDIF
 
@@ -1022,10 +1052,10 @@
     !
     !Config Key   = DO_FLOODINFILT
-    !Config Desc  = Should floodplains reinfiltrate into the soil 
+    !Config Desc  = Should floodplains reinfiltrate into the soil
     !Config If    = RIVER_ROUTING
     !Config Def   = n
     !Config Help  = This parameters allows the user to ask the model
-    !Config         to take into account the flood plains reinfiltration 
-    !Config         into the soil moisture. It then can go 
+    !Config         to take into account the flood plains reinfiltration
+    !Config         into the soil moisture. It then can go
     !Config         back to the slow and fast reservoirs
     !Config Units = [FLAG]
@@ -1039,7 +1069,7 @@
     !Config Def   = n
     !Config Help  = This parameters allows the user to ask the model
-    !Config         to take into account the swamps and return 
-    !Config         the water into the bottom of the soil. It then can go 
-    !Config         back to the atmopshere. This tried to simulate 
+    !Config         to take into account the swamps and return
+    !Config         the water into the bottom of the soil. It then can go
+    !Config         back to the atmopshere. This tried to simulate
     !Config         internal deltas of rivers.
     !Config Units = [FLAG]
@@ -1049,11 +1079,11 @@
     !
     !Config Key   = DO_PONDS
-    !Config Desc  = Should we include ponds 
+    !Config Desc  = Should we include ponds
     !Config If    = RIVER_ROUTING
     !Config Def   = n
     !Config Help  = This parameters allows the user to ask the model
-    !Config         to take into account the ponds and return 
-    !Config         the water into the soil moisture. It then can go 
-    !Config         back to the atmopshere. This tried to simulate 
+    !Config         to take into account the ponds and return
+    !Config         the water into the soil moisture. It then can go
+    !Config         back to the atmopshere. This tried to simulate
     !Config         little ponds especially in West Africa.
     !Config Units = [FLAG]
@@ -1064,10 +1094,10 @@
 
     !Config Key   = SLOW_TCST
-    !Config Desc  = Time constant for the slow reservoir 
-    !Config If    = RIVER_ROUTING 
-    !Config Def   = 25.0 
-    !Config Help  = This parameters allows the user to fix the 
+    !Config Desc  = Time constant for the slow reservoir
+    !Config If    = RIVER_ROUTING
+    !Config Def   = 25.0
+    !Config Help  = This parameters allows the user to fix the
     !Config         time constant (in days) of the slow reservoir
-    !Config         in order to get better river flows for 
+    !Config         in order to get better river flows for
     !Config         particular regions.
     !Config Units = [days]
@@ -1078,5 +1108,5 @@
 !> during the 1 degree NCEP Corrected by Cru (NCC) resolution simulations (Ngo-Duc et al., 2005, Ngo-Duc et al., 2006) and
 !> generalized for all the basins of the world. The "slow reservoir" and the "fast reservoir"
-!> have the highest value in order to simulate the groundwater. 
+!> have the highest value in order to simulate the groundwater.
 !> The "stream reservoir", which represents all the water of the stream, has the lowest value.
 !> Those figures are the same for all the basins of the world.
@@ -1087,53 +1117,53 @@
     !
     !Config Key   = FAST_TCST
-    !Config Desc  = Time constant for the fast reservoir 
-    !Config If    = RIVER_ROUTING 
-    !Config Def   = 3.0 
-    !Config Help  = This parameters allows the user to fix the 
+    !Config Desc  = Time constant for the fast reservoir
+    !Config If    = RIVER_ROUTING
+    !Config Def   = 3.0
+    !Config Help  = This parameters allows the user to fix the
     !Config         time constant (in days) of the fast reservoir
-    !Config         in order to get better river flows for 
+    !Config         in order to get better river flows for
     !Config         particular regions.
     !Config Units = [days]
     CALL getin_p('FAST_TCST', fast_tcst)
-    
+
     !Config Key   = STREAM_TCST
-    !Config Desc  = Time constant for the stream reservoir 
+    !Config Desc  = Time constant for the stream reservoir
     !Config If    = RIVER_ROUTING
     !Config Def   = 0.24
-    !Config Help  = This parameters allows the user to fix the 
+    !Config Help  = This parameters allows the user to fix the
     !Config         time constant (in days) of the stream reservoir
-    !Config         in order to get better river flows for 
+    !Config         in order to get better river flows for
     !Config         particular regions.
     !Config Units = [days]
     CALL getin_p('STREAM_TCST', stream_tcst)
-    
+
     !Config Key   = FLOOD_TCST
-    !Config Desc  = Time constant for the flood reservoir 
+    !Config Desc  = Time constant for the flood reservoir
     !Config If    = RIVER_ROUTING
     !Config Def   = 4.0
-    !Config Help  = This parameters allows the user to fix the 
+    !Config Help  = This parameters allows the user to fix the
     !Config         time constant (in days) of the flood reservoir
-    !Config         in order to get better river flows for 
+    !Config         in order to get better river flows for
     !Config         particular regions.
     !Config Units = [days]
     CALL getin_p('FLOOD_TCST', flood_tcst)
-    
+
     !Config Key   = SWAMP_CST
-    !Config Desc  = Fraction of the river that flows back to swamps 
+    !Config Desc  = Fraction of the river that flows back to swamps
     !Config If    = RIVER_ROUTING
     !Config Def   = 0.2
-    !Config Help  = This parameters allows the user to fix the 
+    !Config Help  = This parameters allows the user to fix the
     !Config         fraction of the river transport
     !Config         that flows to swamps
     !Config Units = [-]
     CALL getin_p('SWAMP_CST', swamp_cst)
-    
+
     !Config Key   = FLOOD_BETA
-    !Config Desc  = Parameter to fix the shape of the floodplain  
+    !Config Desc  = Parameter to fix the shape of the floodplain
     !Config If    = RIVER_ROUTING
     !Config Def   = 2.0
     !Config Help  = Parameter to fix the shape of the floodplain
     !Config         (>1 for convex edges, <1 for concave edges)
-    !Config Units = [-] 
+    !Config Units = [-]
     CALL getin_p("FLOOD_BETA", beta)
     !
@@ -1142,7 +1172,7 @@
     !Config If    = RIVER_ROUTING
     !Config Def   = 0.5
-    !Config Help  = 
-    !Config Units = [-] 
-    CALL getin_p("POND_BETAP", betap)    
+    !Config Help  =
+    !Config Units = [-]
+    CALL getin_p("POND_BETAP", betap)
     !
     !Config Key   = FLOOD_CRI
@@ -1150,6 +1180,6 @@
     !Config If    = DO_FLOODPLAINS or DO_PONDS
     !Config Def   = 2000.
-    !Config Help  = 
-    !Config Units = [mm] 
+    !Config Help  =
+    !Config Units = [mm]
     CALL getin_p("FLOOD_CRI", floodcri)
     !
@@ -1158,6 +1188,6 @@
     !Config If    = DO_FLOODPLAINS or DO_PONDS
     !Config Def   = 2000.
-    !Config Help  = 
-    !Config Units = [mm] 
+    !Config Help  =
+    !Config Units = [mm]
     CALL getin_p("POND_CRI", pondcri)
 
@@ -1166,6 +1196,6 @@
     !Config If    = RIVER_ROUTING
     !Config Def   = 7000
-    !Config Help  = 
-    !Config Units = [kg/m2(routing area)] 
+    !Config Help  =
+    !Config Units = [kg/m2(routing area)]
     max_lake_reservoir = 7000
     CALL getin_p("MAX_LAKE_RESERVOIR", max_lake_reservoir)
@@ -1205,10 +1235,10 @@
        ELSE
           ! Take the value from restart file
-          time_counter = tmp_day(1) 
+          time_counter = tmp_day(1)
        ENDIF
     ENDIF
     CALL bcast(time_counter)
 
-    
+
     ALLOCATE (routing_area_loc(nbpt,nbasmax), stat=ier)
     IF (ier /= 0) CALL ipslerr_p(3,'routing_init','Pb in allocate for routing_area_loc','','')
@@ -1365,5 +1395,5 @@
     CALL restget_p (rest_id, var_name, nbp_glo, 1, 1, kjit, .TRUE., flood_height, "gather", nbp_glo, index_g)
     CALL setvar_p (flood_height, val_exp, 'NO_KEYWORD', zero)
-    
+
     ALLOCATE (pond_frac(nbpt), stat=ier)
     IF (ier /= 0) CALL ipslerr_p(3,'routing_init','Pb in allocate for pond_frac','','')
@@ -1373,5 +1403,5 @@
     CALL restget_p (rest_id, var_name, nbp_glo, 1, 1, kjit, .TRUE., pond_frac, "gather", nbp_glo, index_g)
     CALL setvar_p (pond_frac, val_exp, 'NO_KEYWORD', zero)
-    
+
     var_name = 'flood_frac'
     CALL ioconf_setatt_p('UNITS', '-')
@@ -1379,5 +1409,5 @@
     CALL restget_p (rest_id, var_name, nbp_glo, 1, 1, kjit, .TRUE., flood_frac, "gather", nbp_glo, index_g)
     CALL setvar_p (flood_frac, val_exp, 'NO_KEYWORD', zero)
-    
+
     var_name = 'flood_res'
     CALL ioconf_setatt_p('UNITS','mm')
@@ -1386,5 +1416,5 @@
     CALL setvar_p (flood_res, val_exp, 'NO_KEYWORD', zero)
 !    flood_res = zero
-    
+
     ALLOCATE (lake_reservoir(nbpt), stat=ier)
     IF (ier /= 0) CALL ipslerr_p(3,'routing_init','Pb in allocate for lake_reservoir','','')
@@ -1394,5 +1424,5 @@
     CALL restget_p (rest_id, var_name, nbp_glo, 1, 1, kjit, .TRUE., lake_reservoir, "gather", nbp_glo, index_g)
     CALL setvar_p (lake_reservoir, val_exp, 'NO_KEYWORD', zero)
-    
+
     ALLOCATE (pond_reservoir(nbpt), stat=ier)
     IF (ier /= 0) CALL ipslerr_p(3,'routing_init','Pb in allocate for pond_reservoir','','')
@@ -1404,15 +1434,13 @@
     !
     ! Map of irrigated areas
-    !
-    IF ( do_irrigation ) THEN
-       ALLOCATE (irrigated(nbpt), stat=ier)
-       IF (ier /= 0) CALL ipslerr_p(3,'routing_init','Pb in allocate for irrigated','','')
-       var_name = 'irrigated'
-       CALL ioconf_setatt_p('UNITS', 'm^2')
-       CALL ioconf_setatt_p('LONG_NAME','Surface of irrigated area')
-       CALL restget_p (rest_id, var_name, nbp_glo, 1, 1, kjit, .TRUE., irrigated, "gather", nbp_glo, index_g)
-       CALL setvar_p (irrigated, val_exp, 'NO_KEYWORD', undef_sechiba)
-    ENDIF
-    
+    ! irrigated equal to irrigated_next from slowproc. Here, we initialize to zero.
+    ! Values from slowproc given in routing_main
+    ALLOCATE (irrigated(nbpt), stat=ier)
+    IF (ier /= 0) CALL ipslerr_p(3,'routing_init','Pb in allocate for irrigated','','')
+    var_name = 'irrigated'
+    CALL ioconf_setatt_p('UNITS', 'm^2')
+    CALL ioconf_setatt_p('LONG_NAME','Surface of irrigated area')
+    irrigated(:) = zero
+
     IF ( do_floodplains ) THEN
        ALLOCATE (floodplains(nbpt), stat=ier)
@@ -1443,5 +1471,5 @@
     CALL restget_p (rest_id, var_name, nbp_glo, 1, 1, kjit, .TRUE., lakeinflow_mean, "gather", nbp_glo, index_g)
     CALL setvar_p (lakeinflow_mean, val_exp, 'NO_KEYWORD', zero)
-    
+
     ALLOCATE (returnflow_mean(nbpt), stat=ier)
     IF (ier /= 0) CALL ipslerr_p(3,'routing_init','Pb in allocate for returnflow_mean','','')
@@ -1452,5 +1480,5 @@
     CALL setvar_p (returnflow_mean, val_exp, 'NO_KEYWORD', zero)
     returnflow(:) = returnflow_mean(:)
-    
+
     ALLOCATE (reinfiltration_mean(nbpt), stat=ier)
     IF (ier /= 0) CALL ipslerr_p(3,'routing_init','Pb in allocate for reinfiltration_mean','','')
@@ -1461,11 +1489,21 @@
     CALL setvar_p (reinfiltration_mean, val_exp, 'NO_KEYWORD', zero)
     reinfiltration(:) = reinfiltration_mean(:)
-    
+
     ALLOCATE (irrigation_mean(nbpt), stat=ier)
     IF (ier /= 0) CALL ipslerr_p(3,'routing_init','Pb in allocate for irrigation_mean','','')
+    ALLOCATE (irrigdeficit_mean(nbpt), stat=ier)
+    IF (ier /= 0) CALL ipslerr_p(3,'routing_init','Pb in allocate for irrigdeficit_mean','','')
+    ALLOCATE (irrigadduct_mean(nbpt), stat=ier)
+    IF (ier /= 0) CALL ipslerr_p(3,'routing_init','Pb in allocate for irrigadduct_mean','','')
     ALLOCATE (irrig_netereq(nbpt), stat=ier)
     IF (ier /= 0) CALL ipslerr_p(3,'routing_init','Pb in allocate for irrig_netereq','','')
+    ALLOCATE (irrig_gw_source_mean(nbpt), stat=ier) !
+    IF (ier /= 0) CALL ipslerr_p(3,'routing_init','Pb in allocate for irrig_gw_source_mean','','')!
+    ALLOCATE (irrig_fast_source_mean(nbpt), stat=ier) !
+    IF (ier /= 0) CALL ipslerr_p(3,'routing_init','Pb in allocate for irrig_fast_source_mean','','')!
+    ALLOCATE (irrig_str_source_mean(nbpt), stat=ier) !
+    IF (ier /= 0) CALL ipslerr_p(3,'routing_init','Pb in allocate for irrig_str_source_mean','','')!
     irrig_netereq(:) = zero
-    
+
     IF ( do_irrigation ) THEN
        var_name = 'irrigation'
@@ -1474,9 +1512,39 @@
        CALL restget_p (rest_id, var_name, nbp_glo, 1, 1, kjit, .TRUE., irrigation_mean, "gather", nbp_glo, index_g)
        CALL setvar_p (irrigation_mean, val_exp, 'NO_KEYWORD', zero)
+       var_name = 'irrigdeficit'
+       CALL ioconf_setatt_p('UNITS', 'Kg/dt')
+       CALL ioconf_setatt_p('LONG_NAME','Irrigation deficit')
+       CALL restget_p (rest_id, var_name, nbp_glo, 1, 1, kjit, .TRUE., irrigdeficit_mean, "gather", nbp_glo, index_g)
+       CALL setvar_p (irrigdeficit_mean, val_exp, 'NO_KEYWORD', zero)
+       var_name = 'irrigadduct'
+       CALL ioconf_setatt_p('UNITS', 'Kg/dt')
+       CALL ioconf_setatt_p('LONG_NAME','Artificial irrigation flux from adduction')
+       CALL restget_p (rest_id, var_name, nbp_glo, 1, 1, kjit, .TRUE., irrigadduct_mean, "gather", nbp_glo, index_g)
+       CALL setvar_p (irrigadduct_mean, val_exp, 'NO_KEYWORD', zero)
+       var_name = 'irrig_gw_source'!
+       CALL ioconf_setatt_p('UNITS', 'Kg/dt')
+       CALL ioconf_setatt_p('LONG_NAME','Irrigation from GW reservoir')
+       CALL restget_p (rest_id, var_name, nbp_glo, 1, 1, kjit, .TRUE., irrig_gw_source_mean, "gather", nbp_glo, index_g)
+       CALL setvar_p (irrig_gw_source_mean, val_exp, 'NO_KEYWORD', zero)
+       var_name = 'irrig_fast_source'!
+       CALL ioconf_setatt_p('UNITS', 'Kg/dt')
+       CALL ioconf_setatt_p('LONG_NAME','Irrigation from fast reservoir')
+       CALL restget_p (rest_id, var_name, nbp_glo, 1, 1, kjit, .TRUE., irrig_fast_source_mean, "gather", nbp_glo, index_g)
+       CALL setvar_p (irrig_fast_source_mean, val_exp, 'NO_KEYWORD', zero)
+       var_name = 'irrig_str_source'!
+       CALL ioconf_setatt_p('UNITS', 'Kg/dt')
+       CALL ioconf_setatt_p('LONG_NAME','Irrigation from stream reservoir')
+       CALL restget_p (rest_id, var_name, nbp_glo, 1, 1, kjit, .TRUE., irrig_str_source_mean, "gather", nbp_glo, index_g)
+       CALL setvar_p (irrig_str_source_mean, val_exp, 'NO_KEYWORD', zero)
     ELSE
        irrigation_mean(:) = zero
+       irrig_gw_source_mean(:) = zero
+       irrig_fast_source_mean(:) = zero
+       irrig_str_source_mean(:) = zero
+       irrigdeficit_mean(:) = zero
+       irrigadduct_mean(:) = zero
     ENDIF
-    irrigation(:) = irrigation_mean(:) 
-    
+    irrigation(:) = irrigation_mean(:)
+
     ALLOCATE (riverflow_mean(nbpt), stat=ier)
     IF (ier /= 0) CALL ipslerr_p(3,'routing_init','Pb in allocate for riverflow_mean','','')
@@ -1487,5 +1555,5 @@
     CALL setvar_p (riverflow_mean, val_exp, 'NO_KEYWORD', zero)
     riverflow(:) = riverflow_mean(:)
-    
+
     ALLOCATE (coastalflow_mean(nbpt), stat=ier)
     IF (ier /= 0) CALL ipslerr_p(3,'routing_init','Pb in allocate for coastalflow_mean','','')
@@ -1496,5 +1564,5 @@
     CALL setvar_p (coastalflow_mean, val_exp, 'NO_KEYWORD', zero)
     coastalflow(:) = coastalflow_mean(:)
-    
+
     ! Locate it at the 2m level
     ipn = MINLOC(ABS(diaglev-2))
@@ -1503,5 +1571,5 @@
     IF (ier /= 0) CALL ipslerr_p(3,'routing_init','Pb in allocate for floodtemp','','')
     floodtemp(:) = stempdiag(:,floodtemp_lev)
-    
+
     ALLOCATE(hydrographs(nbpt), stat=ier)
     IF (ier /= 0) CALL ipslerr_p(3,'routing_init','Pb in allocate for hydrographs','','')
@@ -1511,5 +1579,5 @@
     CALL restget_p (rest_id, var_name, nbp_glo, 1, 1, kjit, .TRUE., hydrographs, "gather", nbp_glo, index_g)
     CALL setvar_p (hydrographs, val_exp, 'NO_KEYWORD', zero)
- 
+
     ALLOCATE(slowflow_diag(nbpt), stat=ier)
     IF (ier /= 0) CALL ipslerr_p(3,'routing_init','Pb in allocate for slowflow_diag','','')
@@ -1526,5 +1594,5 @@
          & pond_diag(nbpt), lake_diag(nbpt), stat=ier)
     IF (ier /= 0) CALL ipslerr_p(3,'routing_init','Pb in allocate for fast_diag,..','','')
-    
+
     fast_diag(:) = zero
     slow_diag(:) = zero
@@ -1533,5 +1601,5 @@
     pond_diag(:) = zero
     lake_diag(:) = zero
-    
+
     DO ig=1,nbpt
        totarea = zero
@@ -1566,5 +1634,5 @@
     CALL restget_p (rest_id, var_name, nbp_glo, 1, 1, kjit, .TRUE., floodout_mean, "gather", nbp_glo, index_g)
     CALL setvar_p (floodout_mean, val_exp, 'NO_KEYWORD', zero)
-    
+
     ALLOCATE (runoff_mean(nbpt), stat=ier)
     IF (ier /= 0) CALL ipslerr_p(3,'routing_init','Pb in allocate for runoff_mean','','')
@@ -1574,5 +1642,5 @@
     CALL restget_p (rest_id, var_name, nbp_glo, 1, 1, kjit, .TRUE., runoff_mean, "gather", nbp_glo, index_g)
     CALL setvar_p (runoff_mean, val_exp, 'NO_KEYWORD', zero)
-    
+
     ALLOCATE(drainage_mean(nbpt), stat=ier)
     IF (ier /= 0) CALL ipslerr_p(3,'routing_init','Pb in allocate for drainage_mean','','')
@@ -1582,5 +1650,5 @@
     CALL restget_p (rest_id, var_name, nbp_glo, 1, 1, kjit, .TRUE., drainage_mean, "gather", nbp_glo, index_g)
     CALL setvar_p (drainage_mean, val_exp, 'NO_KEYWORD', zero)
-    
+
     ALLOCATE(transpot_mean(nbpt), stat=ier)
     IF (ier /= 0) CALL ipslerr_p(3,'routing_init','Pb in allocate for transpot_mean','','')
